/*****************************************************************************************************

	Main.cpp	SC02 + CM01 Sample Program

	{Iȃf[^̑MsTvD
	ACM01̑䐔ɍ킹MODULE_NUMύXDl1D
	CM01ID0AԂŐݒ肵ĂD

													2015.7.28 M.Utsumi@ARCDEVICE

******************************************************************************************************/

#include<windows.h>
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<math.h>
#include"SC02.h"
#include"CM01.h"
#include"Measurement.h"

#define MODULE_NUM	1	// ACM01̑䐔

// ControlModuleʃR}h̃eXg
BOOL TestModule( ControlModule *pModule )
{
	if( !pModule->GetVersion() ){
		printf( "Error:%s\n", pModule->Error );
		return( 0 );
	}

	printf( "Ver.%d.%d\r\n", 0x0F & pModule->bVersion >>4, 0x0F & pModule->bVersion );

	printf("Hit any key\n");
	_getch();
	if( !pModule->Blink(3) ){
		printf( "Error:%s\r\n", pModule->Error );
		return( 0 );
	}

	return( TRUE );
}


void SetOutput( CM01 *pModule, int nVal )
{
	// |[gAPIȌꍇ̃f[^ݒ
	if( pModule->bBoardID_PA == CM01_PIO_BOARD ){
		// o͕ݒ erbg 0:óC1:
		pModule->PioBoardA.Word.wDir = 0xFFFF;	// [hPʂŐݒ肷ꍇiPIOA8bit܂ŗLj
		//pModule->PioBoardA.Bit.P1 = 1;@		// rbgPʂŐݒ肷ꍇ

		// o̓f[^̐ݒi|[go͂ɂꍇj
		//pModule->PioBoardA.Word.wData = nVal; // [hPʂŐݒ肷ꍇiPIOA8bit܂ŗL
		//pModule->PioBoardA.Bit.DIR1 = 0;		// rbgPʂŐݒ肷ꍇ
	}

	// |[gB̃f[^ݒ
	switch(  pModule->bBoardID_PB ){
	case CM01_PWM_BOARD:
		pModule->PwmBoard.sPwm1 = nVal;
		pModule->PwmBoard.sPwm2 = nVal;
		break; 
	case CM01_DA_BOARD:
		pModule->DaBoard.sDA = nVal;
		break;
	case CM01_PIO_BOARD:
		// o͕ݒ erbg 0:óC1:
		pModule->PioBoardB.Word.wDir = 0xFFFF;  // [hPʂŐݒ肷ꍇiPIOB10bit܂ŗLj
		//pModule->PioBoardB.Bit.DIR9 = 0;		// rbgPʂŐݒ肷ꍇ

		// o̓f[^̐ݒi|[go͂ɂꍇj
		//pModule->PioBoardB.Word.wData = nVal; // [hPʂŐݒ肷ꍇiPIOB10bit܂ŗLj
		//pModule->PioBoardB.Bit.P9 = 1;		// rbgPʂŐݒ肷ꍇ
		break;	
	}
}


void PrintData( CM01 *pModule )
{
	printf(" ID=%d ", 0x00FF&pModule->bID );

	switch( pModule->bBoardID_PA){
	case CM01_ENC_BOARD:
		printf("enc %d ad %d ", pModule->EncBoard.lEncoder, pModule->EncBoard.wSensor[0] );
		break;
	case CM01_SENSOR_BOARD:
		printf("sens %d  %d  %d  %d  %d  %d  %d  %d ",
			pModule->SensorBoard.wSensor[0], pModule->SensorBoard.wSensor[1],
			pModule->SensorBoard.wSensor[2], pModule->SensorBoard.wSensor[3],
			pModule->SensorBoard.wSensor[4], pModule->SensorBoard.wSensor[5],
			pModule->SensorBoard.wSensor[6], pModule->SensorBoard.wSensor[7]
		);
		break;
	case CM01_PIO_BOARD:
		printf("pioA %04x ", pModule->PioBoardA.Word.wData );
		break;
	}

	// |[gB̃f[^ݒ
	switch(  pModule->bBoardID_PB ){
	case CM01_PWM_BOARD:
		printf("pwm %d ", pModule->PwmBoard.sPwm1 );
		break; 
	case CM01_DA_BOARD:
		printf("da %d ", pModule->DaBoard.sDA );
		break;
	case CM01_PIO_BOARD:
		printf("pioB %04x ", pModule->PioBoardB.Word.wData );
		break;	
	}
}

int main( int argc, char* argv[] )
{
	SC02 sc;
	CM01 cm[MODULE_NUM];
	int nVal, i;
	BOOL loop=TRUE;


// Jn
	printf("Open SC02 ");
	if( !sc.Open( CM_MASTER_ID ) ){
		printf( "Error:%s\r\n", sc.Error );
		return( 0 );
	}
	printf("OK\n");

	// CM01ID0AԂƂȂĂD
	for(i=0;i<MODULE_NUM;i++){

		printf("Open CM01 ID=%d ", i );
		if( !cm[i].Open( &sc, 0, (BYTE)i+1 )){
			printf( "Error:%s", cm[i].Error );
			printf("Close SC02\n");
			sc.Close();
			return( 0 );
		}
		printf("OK\n");
	}

// {Iȃf[^̑MDo̓f[^̓NXCM01̃oϐgp

	MES_StartTimeCount();	// ԌvJn

	// f[^̏l
	nVal= 0;

	while(loop){
		printf("%02d:%02d:%02d dt %.3fms ",
			(int)(MES_dTime_cur/60.0f),(int)MES_dTime_cur%60,(int)(100.0f*MES_dTime_cur)%100, MES_dTime_int * 1000.0f);

		if(_kbhit()){
			switch(_getch()){
            case '7': nVal++; break;
			case '4': if( nVal > 0 ) nVal = -nVal;  break;
			case '1': nVal--; break;
            case '8': nVal+=10; break;
			case '5': nVal = 0;  break;
			case '2': nVal-=10; break;
            case '9': nVal+=100; break;
			case '6': if( nVal < 0 ) nVal = -nVal;  break;
			case '3': nVal-=100; break;
			case 27:
				loop = FALSE;
				nVal = 0;
				break; //GXP[vŏI
			}
		}
		
		// o̓f[^̐ݒ
		for(i=0;i<MODULE_NUM;i++) SetOutput( &cm[i], nVal );
		
		MES_GetTimeCount(); // ʐMԌv
		// f[^M
		for(i=0;i<MODULE_NUM-1;i++){
			if(!cm[i].Exchange(FALSE) ){ // Exchange(FALSE)̎_ł͑MȂD
				printf("Error:%s", cm[i].Error );
				printf("Close SC02\n");
				sc.Close();
				return(1);
			}
		}
		if(!cm[i].Exchange(TRUE) ){ // Exchange(TRUE)̎_ł܂Ƃ߂đMD
			printf("Error:%s", cm[i].Error );
			printf("Close SC02\n");
			sc.Close();
			return(1);
		}

		MES_GetTimeCount(); // ʐMԌv

		// ̓f[^̕\
		for(i=0;i<MODULE_NUM;i++) PrintData( &cm[i] );
		printf("\n");

	    Sleep(100);
	}
	
// I
	for(i=0;i<MODULE_NUM;i++){
		printf("Close CM01 ID=%d ", i );
		if( !cm[i].Close() ){
			printf("Error:%s", cm[i].Error );
		}else{
			printf("OK\r\n");
		}
	}

	printf("Close SC02 ");
	sc.Close();
	printf("OK\n");

	return(1);
}

